import time
import sys
import os 
import random 
import re
import termios
import enum
from typing import Any, Iterable, Optional, Union

class ColorConsole(enum.Enum):
    """
    枚举类 枚举终端的颜色
    """
    Black = 0
    White = 1
    Cyan = 2
    Blue = 3
    Green = 4
    Yellow = 5
    Red = 6

class ColorPixel:
    def __init__(self):
        self.color_pixel = None
    
    def SetColor(self, _r : int, _g : int, _b : int):
        self.color_pixel = f"\033[48;2;{_r};{_g};{_b}m"
        
    def GetColor(self, txt):
        return f"{self.color_pixel}{txt}\033[0m"
            
class Press:                                                              
    def getch(self):            
        fd = sys.stdin.fileno()                                             
        old_setting = termios.tcgetattr(fd)
        new_setting = termios.tcgetattr(fd)
        new_setting[3] = new_setting[3] & ~termios.ECHO & ~ termios.ICANON
        try:
            termios.tcsetattr(fd, termios.TCSADRAIN, new_setting)
            get = sys.stdin.read(1)
            if get:
                return get
        finally:
            termios.tcsetattr(fd, termios.TCSADRAIN, old_setting)

class Printf:
    def __init__(self):
        self.ls = []
        
    def printf(self,words):
        for i in range(len(words)):
            print(words[i],end="",flush = True)
            time.sleep(0.03)
            self.ls.append(words[i])
        print()
        
    def lists(self):
        print(self.ls)
    # @staticmethod
    
    def clean(self):
        print("\033c",end="",flush = True)
            

# Copyright (c) 2023 Qian
class Composite: #复合组件总类
    def unary_choose(self,choose_list): #一元选择器
        n2 = 1 #建立一个初始量
        answer = "" #建立一个问答字符串
        while answer != "y":
            printf.clean()
            n1 = 1
            print("选择：")
            for i in choose_list:
                if n1 == n2:
                    print(f"    \033[32m{str(n1)}.{i}\033[m")
                else:
                    print(f"    {str(n1)}.{i}")
                n1+=1
            print("请输入：(w/s上下，y选中)")
            answer = press_.getch()
            if answer == "s":
                if n2 != len(choose_list):
                    n2 += 1
                else:
                    n2 = 1
            if answer == "w":
                if n2 != 1:
                    n2 -= 1
                else:
                    n2 = len(choose_list)
        printf.clean()
        return n2
        
color_pixel = ColorPixel()

press_ = Press()

printf = Printf()

_composite = Composite()

# Copyright [C] 2023 LinLin 用于伪装成numpy库的类
class amap:
    def __init__(self, l):
        self.l=list(l)
        
    def __str__(self):
        return str(list(self.l))
        
    def __add__(self, other):
        if type(other)==amap:
            d=map(lambda x,y:x+y,self.l,other.l)
        else:
            d=map(lambda x:x+other,self.l)
        return amap(d)
        
    def __sub__(self, other):
        if type(other)==amap:
            d=map(lambda x,y:x-y,self.l,other.l)
        else:
            d=map(lambda x:other,self.l)
        return amap(d)
        
    def __mul__(self, other):
        if type(other)==amap:
            d=map(lambda x,y:x*y,self.l,other.l)
        else:
            d=map(lambda x:x*other,self.l)
        return amap(d)
        
    def __truediv__(self, other):
        if type(other)==amap:
            d=map(lambda x,y:x/y,self.l,other.l)
        else:
            d=map(lambda x:x/other,self.l)
        return amap(d)
        
    def __mod__(self, other):
        if type(other)==amap:
            d=map(lambda x,y:x%y,self.l,other.l)
        else:
            d=map(lambda x:x%other,self.l)
        return amap(d)
        
    def __pow__(self, other):
        if type(other)==amap:
            d=map(lambda x,y:x**y,self.l,other.l)
        else:
            d=map(lambda x:x**other,self.l)
        return amap(d)
        
    def __floordiv__(self, other):
        if type(other) == amap:
            d=map(lambda x ,y :x // y, self.l, other.l)
        else:
            d=map(lambda x:x//other,self.l)
        return amap(d)
        
    def __setitem__(self, index, ro):
        self.l = list(self.l)
        eif.l[index] = ro
        
    def __getitem__(self, index):
        return list(self.l)[index]
        
    def __len__(self):
        return len(list(self.l))
        
    def __cmp__(self, other):
        return list(self.l)==list(other)

class Figure:
    """图像类 用于展示矩形、"""
    def square(self, _x : int, _y : int, _item):
        return [[_item for i in range(_x)]for j in range(_y)]
    
    def output(self, _list):
        for i in range(len(_list)):
            for j in range(len(_list[i])):
                print(_list[i][j], end = "")
            print()
    
    def exchage(self, _list, value):
        for i in range(len(_list)):
            for j in range(len(_list[i])):
                _list[i][j] = value
        return _list
        
    def change(self, _x : int, _y : int, _list, value):
        _list[x-1][y-1] = value
        
    def add(self, _x1 : int, _x2 : int, _y1 : int, _y2 : int, _list, value):
        _list[_x1 : _x2][_y1 : _y2] = value
        
    def image(self, _color):
        pass

_figure = Figure()
